"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var IConfiguration_1 = require("./IConfiguration");
var Configuration_1 = require("./Configuration");
var core_1 = require("@ts-ioc/core");
var platform_server_1 = require("@ts-ioc/platform-server");
var index_1 = require("./core/index");
var index_2 = require("./aop/index");
var Log4jsAdapter_1 = require("./logAdapter/Log4jsAdapter");
var aop_1 = require("@ts-ioc/aop");
var logs_1 = require("@ts-ioc/logs");
/**
 * mvc applaction bootstrap.
 *
 * @export
 * @class Bootstrap
 */
var Bootstrap = /** @class */ (function (_super) {
    __extends(Bootstrap, _super);
    /**
     * Creates an instance of WebApplication.
     * @param {string} rootdir
     * @param {Type<any>} [appType]
     * @memberof WebApplication
     */
    function Bootstrap(rootdir) {
        var _this = _super.call(this, rootdir) || this;
        _this.middlewares = [];
        _this.beforeSMdls = [];
        _this.afterSMdls = [];
        return _this;
    }
    /**
     * create new application.
     *
     * @static
     * @param {string} rootdir
     * @returns
     * @memberof WebApplication
     */
    Bootstrap.create = function (rootdir) {
        return new Bootstrap(rootdir);
    };
    /**
     * use middleware `fn` or  `MiddlewareFactory`.
     *
     * @param {(IMiddleware | Middleware | Token<any>)} middleware
     * @returns {this}
     * @memberof Bootstrap
     */
    Bootstrap.prototype.use = function (middleware) {
        this.middlewares.push(middleware);
        return this;
    };
    Bootstrap.prototype.useServer = function (middleware, afterMvc) {
        if (afterMvc === void 0) { afterMvc = true; }
        if (afterMvc) {
            this.afterSMdls.push(middleware);
        }
        else {
            this.beforeSMdls.push(middleware);
        }
        return this;
    };
    Bootstrap.prototype.useListener = function (listener) {
        this._listener = listener;
    };
    /**
     * use boostrap to start application.
     *
     * @template T
     * @param {Type<T>} [appModule]
     * @returns {Promise<T>}
     * @memberof Bootstrap
     */
    Bootstrap.prototype.run = function (appModule) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.bootstrap(appModule)];
            });
        });
    };
    /**
     * bootstrap mvc application with App Module.
     *
     * @template T
     * @param {Type<T>} [appModule]
     * @returns {Promise<T>}
     * @memberof Bootstrap
     */
    Bootstrap.prototype.bootstrap = function (appModule) {
        return __awaiter(this, void 0, void 0, function () {
            var appType, app, cfg, container, config, server, port;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        appType = appModule || index_1.Application;
                        return [4 /*yield*/, _super.prototype.bootstrap.call(this, appType)];
                    case 1:
                        app = _a.sent();
                        if (!core_1.isFunction(app.getServer) || !core_1.isFunction(app.use) || !core_1.isFunction(app.getKoa)) {
                            console.error('configuration bootstrap or bootstrap with module is not right application implements IApplication.');
                        }
                        return [4 /*yield*/, this.getConfiguration()];
                    case 2:
                        cfg = _a.sent();
                        return [4 /*yield*/, this.getContainer()];
                    case 3:
                        container = _a.sent();
                        this.setupServerMiddwares(app, container, this.beforeSMdls);
                        this.setupMiddwares(app, container, cfg.beforeMiddlewares, cfg.excludeMiddlewares);
                        this.setupMiddwares(app, container, cfg.useMiddlewares, cfg.excludeMiddlewares.concat(cfg.afterMiddlewares));
                        this.setupRoutes(cfg, container);
                        this.setupMiddwares(app, container, cfg.afterMiddlewares, cfg.excludeMiddlewares);
                        this.setupServerMiddwares(app, container, this.afterSMdls);
                        config = container.get(IConfiguration_1.ConfigurationToken);
                        server = app.getServer();
                        port = config.port || parseInt(process.env.PORT || '0');
                        if (config.hostname) {
                            server.listen(port, config.hostname, this._listener);
                        }
                        else {
                            server.listen(port, this._listener);
                        }
                        console.log('service listen on port: ', port);
                        return [2 /*return*/, app];
                }
            });
        });
    };
    Bootstrap.prototype.setConfigRoot = function (config) {
        config.rootdir = config.rootdir ? platform_server_1.toAbsolutePath(this.rootdir, config.rootdir) : this.rootdir;
    };
    Bootstrap.prototype.getDefaultConfig = function () {
        return new Configuration_1.Configuration();
    };
    Bootstrap.prototype.getMetaConfig = function (appModule) {
        var cfg;
        if (core_1.hasClassMetadata(index_1.AppModule, appModule)) {
            var meta = core_1.getTypeMetadata(index_1.AppModule, appModule);
            console.log(meta);
            if (meta && meta.length) {
                return meta[0];
            }
        }
        return _super.prototype.getMetaConfig.call(this, appModule);
    };
    Bootstrap.prototype.initContainer = function (config, container) {
        return __awaiter(this, void 0, void 0, function () {
            var modules, controllers, aops, servers, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!container.has(aop_1.AopModule)) {
                            container.register(aop_1.AopModule);
                        }
                        if (!container.has(logs_1.LogModule)) {
                            container.register(logs_1.LogModule);
                        }
                        return [4 /*yield*/, _super.prototype.initContainer.call(this, config, container)];
                    case 1:
                        _c.sent();
                        container.registerSingleton(IConfiguration_1.ConfigurationToken, config);
                        container.registerSingleton(Configuration_1.Configuration, config);
                        this.registerDefaults(container);
                        if (!this.middlewares) return [3 /*break*/, 3];
                        return [4 /*yield*/, (_a = this.builder).loadModule.apply(_a, [container].concat(this.middlewares.filter(function (m) { return core_1.isClass(m); })))];
                    case 2:
                        _c.sent();
                        _c.label = 3;
                    case 3:
                        if (!config.middlewares) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.builder.loadModule(container, {
                                basePath: config.rootdir,
                                files: config.middlewares
                            })];
                    case 4:
                        modules = _c.sent();
                        if (!config.useMiddlewares || config.useMiddlewares.length < 1) {
                            config.useMiddlewares = this.middlewares.concat(modules);
                        }
                        else {
                            config.useMiddlewares = this.middlewares.concat(config.useMiddlewares);
                        }
                        _c.label = 5;
                    case 5:
                        // register default
                        this.registerDefaultMiddlewars(container);
                        if (!config.controllers) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.builder.loadModule(container, {
                                basePath: config.rootdir,
                                files: config.controllers
                            })];
                    case 6:
                        controllers = _c.sent();
                        if (!config.useControllers || config.useControllers.length < 1) {
                            config.useControllers = controllers;
                        }
                        _c.label = 7;
                    case 7:
                        if (config.logConfig) {
                            container.registerSingleton(logs_1.LogConfigureToken, config.logConfig);
                        }
                        if (config.debug) {
                            container.register(index_2.DebugLogAspect);
                        }
                        container.register(index_2.AuthAspect);
                        if (!config.aop) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.builder.loadModule(container, {
                                basePath: config.rootdir,
                                files: config.aop
                            })];
                    case 8:
                        aops = _c.sent();
                        config.usedAops = aops;
                        _c.label = 9;
                    case 9: return [4 /*yield*/, (_b = this.builder).loadModule.apply(_b, [container].concat(this.beforeSMdls.concat(this.afterSMdls).filter(function (m) { return core_1.isClass(m); })))];
                    case 10:
                        servers = _c.sent();
                        if (servers && servers.length) {
                            config.usedServerMiddlewares = servers;
                        }
                        return [2 /*return*/, container];
                }
            });
        });
    };
    Bootstrap.prototype.registerDefaultMiddlewars = function (container) {
        index_1.registerDefaultMiddlewars(container);
    };
    Bootstrap.prototype.registerDefaults = function (container) {
        index_1.registerDefaults(container);
        container.register(Log4jsAdapter_1.Log4jsAdapter);
    };
    Bootstrap.prototype.setupRoutes = function (config, container) {
        var router = container.get(config.routerMiddlewate || index_1.Router);
        router.register.apply(router, config.useControllers);
        router.setup();
    };
    Bootstrap.prototype.setupMiddwares = function (app, container, middlewares, excludes) {
        if (!middlewares || middlewares.length < 1) {
            return app;
        }
        middlewares.forEach(function (m) {
            if (!m) {
                return;
            }
            if (excludes && excludes.length > 0 && excludes.indexOf(m) > 0) {
                return;
            }
            if (core_1.isToken(m)) {
                var middleware = container.get(m);
                if (core_1.isFunction(middleware.setup)) {
                    middleware.setup();
                }
            }
            else if (core_1.isFunction(m)) {
                app.use(m);
            }
        });
        return app;
    };
    Bootstrap.prototype.setupServerMiddwares = function (app, container, middlewares) {
        if (!middlewares || middlewares.length < 1) {
            return;
        }
        middlewares.forEach(function (m) {
            if (!m) {
                return;
            }
            if (core_1.isToken(m)) {
                var middleware = container.get(m);
                if (core_1.isFunction(middleware.setup)) {
                    middleware.setup();
                }
            }
            else if (core_1.isFunction(m)) {
                m(app, container);
            }
        });
    };
    Bootstrap.classAnnations = { "name": "Bootstrap", "params": { "constructor": ["rootdir"], "create": ["rootdir"], "use": ["middleware"], "useServer": ["middleware", "afterMvc"], "useListener": ["listener"], "run": ["appModule"], "bootstrap": ["appModule"], "setConfigRoot": ["config"], "getDefaultConfig": [], "getMetaConfig": ["appModule"], "initContainer": ["config", "container"], "registerDefaultMiddlewars": ["container"], "registerDefaults": ["container"], "setupRoutes": ["config", "container"], "setupMiddwares": ["app", "container", "middlewares", "excludes"], "setupServerMiddwares": ["app", "container", "middlewares"] } };
    return Bootstrap;
}(platform_server_1.PlatformServer));
exports.Bootstrap = Bootstrap;

//# sourceMappingURL=sourcemaps/Bootstrap.js.map
