"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ts-ioc/core");
var logs_1 = require("@ts-ioc/logs");
var aop_1 = require("@ts-ioc/aop");
/**
 * debug lod aspect.
 *
 * @export
 * @class DebugLogAspect
 * @extends {LoggerAspect}
 */
var DebugLogAspect = /** @class */ (function (_super) {
    __extends(DebugLogAspect, _super);
    function DebugLogAspect(container) {
        return _super.call(this, container) || this;
    }
    DebugLogAspect.prototype.logging = function (joinPoint) {
        var level;
        switch (joinPoint.state) {
            case aop_1.JoinpointState.AfterThrowing:
                level = logs_1.Level.error;
                break;
            case aop_1.JoinpointState.AfterReturning:
                level = logs_1.Level.debug;
                break;
            case aop_1.JoinpointState.After:
            case aop_1.JoinpointState.Before:
                level = logs_1.Level.trace;
                break;
        }
        this.processLog(joinPoint, null, null, level);
    };
    DebugLogAspect.classAnnations = { "name": "DebugLogAspect", "params": { "constructor": ["container"], "logging": ["joinPoint"] } };
    __decorate([
        aop_1.Around('execution(*.*)'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [aop_1.Joinpoint]),
        __metadata("design:returntype", void 0)
    ], DebugLogAspect.prototype, "logging", null);
    DebugLogAspect = __decorate([
        core_1.Singleton,
        aop_1.Aspect,
        __param(0, core_1.Inject(core_1.ContainerToken)),
        __metadata("design:paramtypes", [Object])
    ], DebugLogAspect);
    return DebugLogAspect;
}(logs_1.LoggerAspect));
exports.DebugLogAspect = DebugLogAspect;

//# sourceMappingURL=../sourcemaps/aop/DebugLogAspect.js.map
