"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var aop_1 = require("@ts-ioc/aop");
var Koa = require("koa");
var core_1 = require("@ts-ioc/core");
var http = require("http");
// import * as http2 from 'http2';
var https = require("https");
var IConfiguration_1 = require("../IConfiguration");
var logs_1 = require("@ts-ioc/logs");
/**
 * Application token.
 */
exports.ApplicationToken = new core_1.InjectToken('__MVC_Application');
/**
 * Application of type mvc.
 *
 * @export
 * @class Application
 * @extends {Koa}
 */
var Application = /** @class */ (function () {
    function Application() {
    }
    Application.prototype.getKoa = function () {
        if (!this.koa) {
            this.koa = new Koa();
        }
        return this.koa;
    };
    Application.prototype.getConfiguration = function () {
        return this.container.get(IConfiguration_1.ConfigurationToken);
    };
    Application.prototype.getLoggerManger = function () {
        if (!this._loggerMgr) {
            var cfg = this.getConfiguration();
            this._loggerMgr = this.container.resolve(logs_1.ConfigureLoggerManagerToken, { config: cfg.logConfig });
        }
        return this._loggerMgr;
    };
    Application.prototype.getLogger = function (name) {
        return this.getLoggerManger().getLogger(name);
    };
    Application.prototype.getServer = function () {
        if (!this.server) {
            var cfg = this.getConfiguration();
            if (cfg.httpsOptions) {
                this.server = https.createServer(cfg.httpsOptions, this.getKoa().callback);
            }
            else {
                this.server = http.createServer(this.getKoa().callback());
            }
        }
        return this.server;
    };
    Application.prototype.use = function (middleware) {
        this.getKoa().use(middleware);
    };
    Application.classAnnations = { "name": "Application", "params": { "constructor": [], "getKoa": [], "getConfiguration": [], "getLoggerManger": [], "getLogger": ["name"], "getServer": [], "use": ["middleware"] } };
    __decorate([
        core_1.Inject(core_1.ContainerToken),
        __metadata("design:type", Object)
    ], Application.prototype, "container", void 0);
    Application = __decorate([
        aop_1.NonePointcut,
        core_1.Singleton(exports.ApplicationToken),
        __metadata("design:paramtypes", [])
    ], Application);
    return Application;
}());
exports.Application = Application;

//# sourceMappingURL=../sourcemaps/core/Application.js.map
