"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ts-ioc/core");
var index_1 = require("../decorators/index");
var ControllerRoute_1 = require("./ControllerRoute");
var aop_1 = require("@ts-ioc/aop");
var RouteBuilder = /** @class */ (function () {
    function RouteBuilder() {
    }
    RouteBuilder.prototype.build = function (router) {
        var controllers = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            controllers[_i - 1] = arguments[_i];
        }
        var root = router.getRoot();
        var contrkey = index_1.Controller.toString();
        controllers.forEach(function (ctrl) {
            if (core_1.isClass(ctrl)) {
                var ctrlmetadatas = core_1.getTypeMetadata(contrkey, ctrl);
                ctrlmetadatas.forEach(function (ctlmeta) {
                    if (!ctlmeta) {
                        return;
                    }
                    var prefix = ctlmeta.routePrefix;
                    if (prefix && !/^\//.test(prefix)) {
                        prefix = '/' + prefix;
                    }
                    var route = root.match(prefix);
                    var ctrlRoute = new ControllerRoute_1.ControllerRoute(prefix, ctrl);
                    if (route.isEmpty()) {
                        root.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                    else {
                        route.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                });
            }
        });
        return root;
    };
    RouteBuilder.classAnnations = { "name": "RouteBuilder", "params": { "constructor": [], "build": ["router", "controllers"] } };
    RouteBuilder = __decorate([
        aop_1.NonePointcut,
        core_1.Injectable,
        __metadata("design:paramtypes", [])
    ], RouteBuilder);
    return RouteBuilder;
}());
exports.RouteBuilder = RouteBuilder;

//# sourceMappingURL=../../sourcemaps/core/router/RouteBuilder.js.map
