"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var logs_1 = require("@ts-ioc/logs");
var aop_1 = require("@ts-ioc/aop");
var core_1 = require("@ts-ioc/core");
/**
 * log4js logger manager adapter.
 *
 * @export
 * @class Log4jsAdapter
 * @implements {ILoggerManger}
 */
var Log4jsAdapter = /** @class */ (function () {
    function Log4jsAdapter() {
    }
    Log4jsAdapter.prototype.getLog4js = function () {
        if (!this._log4js) {
            this._log4js = require('log4js');
        }
        return this._log4js;
    };
    Log4jsAdapter.prototype.configure = function (config) {
        this.getLog4js().configure(config);
    };
    Log4jsAdapter.prototype.getLogger = function (name) {
        return this.getLog4js().getLogger(name);
    };
    Log4jsAdapter.classAnnations = { "name": "Log4jsAdapter", "params": { "constructor": [], "getLog4js": [], "configure": ["config"], "getLogger": ["name"] } };
    Log4jsAdapter = __decorate([
        aop_1.NonePointcut,
        core_1.Singleton,
        core_1.Injectable(logs_1.LoggerManagerToken, 'log4js'),
        __metadata("design:paramtypes", [])
    ], Log4jsAdapter);
    return Log4jsAdapter;
}());
exports.Log4jsAdapter = Log4jsAdapter;

//# sourceMappingURL=../sourcemaps/logAdapter/Log4jsAdapter.js.map
